/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 178 by dpavlin, Tue Mar 16 15:06:30 2010 UTC revision 226 by dpavlin, Tue Aug 10 17:03:15 2010 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /bin/sh
2    ### BEGIN INIT INFO
3  # based on Tony Risinger code from lxc-users  # Provides:          lxc-watchdog
4    # Required-Start:    $remote_fs $named $network $time
5    # Required-Stop:     $remote_fs $named $network
6    # Required-Start:    
7    # Required-Stop:    
8    # Default-Start:     2 3 4 5
9    # Default-Stop:      0 1 6
10    # Short-Description: Manage Linux Containers startup/shutdown
11    # Description:       Uses clever inotify hack to monitor container's
12    #                    halt/reboot events watching /var/run/utmp
13    ### END INIT INFO
14    
15    # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
16    #
17    # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
26    
 name=$1  
27    
28  if [ ! -e /var/lib/lxc/$name/config ] ; then  lxc_exists() {
29          echo "Usage: $0 name"          name=$1
30          ls /var/lib/lxc/*/config | cut -d/ -f5  
31          exit 1          if [ ! -e /var/lib/lxc/$name/config ] ; then
32  fi                  echo "Usage: $0 name"
33                    lxc_status
34                    exit 1
35            fi
36    }
37    
 rootfs=`grep lxc.rootfs /var/lib/lxc/$name/config | cut -d= -f2`  
 echo "$name rootfs $rootfs"  
38    
39  # cleanup init scripts which don't work in containers  lxc_rootfs() {
40  ls $rootfs/etc/rc?.d/*umountfs 2>/dev/null | xargs -i rm -v {}          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41  ls $rootfs/etc/rc?.d/*umountroot 2>/dev/null | xargs -i rm -v {}  }
42  ls $rootfs/etc/rc?.d/*hwclock* 2>/dev/null | xargs -i rm -v {}  
43    
44    lxc_status() {
45            ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
46                    boot="-"
47                    hostname=`cat $(lxc_rootfs $name)/etc/hostname`
48                    ip=`grep address $(lxc_rootfs $name)/etc/network/interfaces | sed 's/.*address //'`
49                    test -s /var/lib/lxc/$name/on_boot && boot="boot"
50                    echo "$name $status $boot $(lxc_rootfs $name) $ip $hostname"
51            done ) | column -t
52    }
53    
54    
55    cleanup_init_scripts() {
56            rootfs=$(lxc_rootfs $1)
57    
58            ls \
59                    $rootfs/etc/rc?.d/*umountfs \
60                    $rootfs/etc/rc?.d/*umountroot \
61                    $rootfs/etc/rc?.d/*hwclock* \
62                    $rootfs/etc/rc?.d/*udev* \
63            2>/dev/null | xargs -i rm -v {}
64    
65            echo $1 > $rootfs/etc/hostname
66    }
67    
68    
69    setup_inittab() {
70            rootfs=$(lxc_rootfs $1)
71            remove=$2
72            add=$3
73    
74            # let container respond to kill -SIGPWR
75            inittab=$rootfs/etc/inittab
76            if ! grep "$add" ${inittab} >/dev/null ; then
77                    grep -v "$remove" ${inittab} > ${inittab}.new
78                    echo $add >> ${inittab}.new
79                    mv ${inittab}.new ${inittab}
80                    echo "$inittab modified with $add"
81            fi
82    }
83    
84    
85    lxc_log() {
86            echo `date +%Y-%m-%dT%H:%M:%S` $*
87    }
88    
89    
90    lxc_kill() {
91            name=$1
92            sig=$2
93    
94            init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`
95            if [ -z "$init_pid" ] ; then
96                    lxc-info -n $name
97                    exit 1
98            fi
99            lxc_log "$name kill $sig $init_pid"
100            /bin/kill $sig $init_pid
101    }
102    
103    lxc_stop() {
104            lxc_log "$name stop"
105            lxc_kill $name -SIGPWR
106            lxc-wait -n $name -s STOPPED
107            lxc_log "$name stoped"
108    #       rm -f /var/lib/lxc/${name}/on_boot
109    }
110    
111    
112    lxc_start() {
113            name=$1
114    
115            if ! lxc-info -n $name | grep RUNNING ; then
116                    lxc_log "$name start"
117                    lxc-start -n $name -o /tmp/${name}.log -d
118                    lxc-wait  -n $name -s RUNNING
119                    lxc-info  -n $name
120                    test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
121            fi
122    }
123    
124  lxc-info -n $name | grep RUNNING || lxc-start -d -n $name -o /tmp/${name}.log && echo "$name start"  lxc_watchdog() {
125    name=$1
126    rootfs=$(lxc_rootfs $1)
127    
128  while true; do  while true; do
         # time of 5 minutes on it JUST IN CASE...  
129          vps_utmp=${rootfs}/var/run/utmp          vps_utmp=${rootfs}/var/run/utmp
130          inotifywait -qqt 300 ${vps_utmp}          tasks=`wc -l < /cgroup/${name}/tasks`
131          if [ $(wc -l < /cgroup/${name}/tasks) -eq 1 ]; then          test -z "$tasks" && exit 1
132            if [ "$tasks" -eq 1 ]; then
133    
134                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel ${vps_utmp})"
135                  echo "# $name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
136    
137                  case $runlevel in                  case $runlevel in
138                  N*)                  N*)
139                          # nothing for new boot state                          # nothing for new boot state
140                  ;;                  ;;
141                  ??0)                  ??0)
142                          echo "$name halt"                          lxc_log "$name halt"
143                          lxc-stop -n "${name}"                          lxc-stop -n "${name}"
144                            lxc-wait -n ${name} -s STOPPED
145                          break                          break
146                  ;;                  ;;
147                  ??6)                  ??6)
148                          echo "$name reboot";                          lxc_log "$name reboot";
149                          lxc-stop -n ${name}                          lxc-stop -n ${name}
150                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
                         mount /mnt/llin -o remount,rw  
151                          lxc-start -d -n ${name} -o /tmp/${name}.log                          lxc-start -d -n ${name} -o /tmp/${name}.log
152                  ;;                  ;;
153                  *)                  *)
# Line 54  while true; do Line 156  while true; do
156                          [ "$state" = "RUNNING" ] || break                          [ "$state" = "RUNNING" ] || break
157                  ;;                  ;;
158                  esac                  esac
159            else
160                    lxc_log "$name $tasks tasks"
161          fi          fi
162    
163            # time of 5 minutes on it JUST IN CASE...
164            inotifywait -qqt 300 ${vps_utmp}
165  done  done
166    
167    lxc_log "$name watchdog exited"
168    
169    }
170    
171    
172    usage() {
173            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
174            exit 3
175    }
176    
177    command_on_lxc() {
178    command=$1
179    shift
180    
181    echo "# $command $1"
182    
183    case "$command" in
184    
185    start)
186            lxc_exists $1
187            cleanup_init_scripts $1
188            setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
189            setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
190            setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
191            lxc_start $1
192            # give container 5 seconds to start more than one process
193            ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
194            ;;
195    stop|halt)
196            lxc_exists $1
197            lxc_stop $1
198            ;;
199    reload|force-reload|restart|reboot)
200            lxc_kill $1 -SIGINT
201            ;;
202    watchdog)
203            lxc_watchdog $1
204            ;;
205    boot)
206            echo $1 > /var/lib/lxc/$1/on_boot
207            ;;
208    disable)
209            echo -n > /var/lib/lxc/$1/on_boot
210            ;;
211    *)
212            usage
213            ;;
214    
215    esac
216    
217    }
218    
219    command=$1
220    test -z "$command" && usage
221    test "$command" = "status" && lxc_status && exit
222    shift
223    
224    if [ -z "$1" ] ; then
225            ls /var/lib/lxc/*/on_boot | while read path ; do
226                    name=`echo $path | cut -d/ -f5`
227                    if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
228                            command_on_lxc $command $name
229                    else
230                            echo "# skip $command $name"
231                    fi
232            done
233    else
234            while [ ! -z "$1" ] ; do
235                    command_on_lxc $command $1
236                    shift
237            done
238    fi
239    

Legend:
Removed from v.178  
changed lines
  Added in v.226

  ViewVC Help
Powered by ViewVC 1.1.26